#!/usr/bin/python
# Parses the text files available from the ??utlzd.zip files available at:
#    http://www.nanpa.com/number_resource_info/co_code_assignments1.html
# and generates a gdbm-format output file that maps from
# NPA-NXX prefix to information about that central office code assignment.

import gdbm
import re,string,os,sys
import nanpa

if len(sys.argv) < 3:
    print "usage:  nanpa2gdbm.py outfile infiles ..."
    sys.exit(-1)

db = gdbm.open(sys.argv[1], "cf")

for filename in sys.argv[2:]:
    print "################## converting "+filename
    inf = open(filename, "r")
    data = nanpa.Nanpa(inf)
    rows = data.get_rows()
    curline = 0
    for r in rows:
        npanxx = r.NPA_NXX
        if npanxx:
            db[npanxx] = r.summary()
        curline = curline + 1
        if 0 == curline % 1000:
            print "#dumping line %d (%.1f%%)"%(curline,
                                               (100.*curline)/len(rows))
    inf.close()
    
db.close()



