#!/usr/bin/python
#
# Parses the text files available from the ??utlzd.zip files available at:
#    http://www.nanpa.com/number_resource_info/co_code_assignments1.html
# and generates a rolodex-format output file.
#

import re,string,os,sys
import nanpa
import time

if len(sys.argv) < 3:
    print "usage:  nanpa2rolodex.py outfile infiles ..."
    sys.exit(-1)

db = open(sys.argv[1], "w")
db.write("# From http://www.nanpa.com/number_resource_info/co_code_assignments1.html\n")
db.write("# Last generated: %s\n"%(time.asctime(time.localtime())))
db.write("# Contains: %s\n"%(string.join(sys.argv[2:])))
db.write("---\n")
db.write("NPA-NXX-\\d\\d\\d\\d RateCenter      , St (Switch     ) Company / AdditionalInfo\n")

for filename in sys.argv[2:]:
    print "################## converting "+filename
    db.write("# File: %s\n"%(filename))
    inf = open(filename, "r")
    data = nanpa.Nanpa(inf)
    rows = data.get_rows()
    curline = 0
    for r in rows:
        npanxx = r.NPA_NXX
        if npanxx:
            db.write("%s-\\d\\d\\d\\d %s\n"%(npanxx, r.summary()))
        curline = curline + 1
        if 0 == curline % 1000:
            print "#dumping line %d (%.1f%%)"%(curline,
                                               (100.*curline)/len(rows))
    inf.close()
    
db.close()
